; ........................................
; :  Blitz Lemmings                      :
; :  By Geoff Storey                     :
; :  Email geoffrey.storey@ntlworld.com  :
; ........................................
; 
AppTitle "Blitz Lemmings By Geoff Storey."
Global width=800:Global height=600
Graphics width,height
HidePointer
SetBuffer BackBuffer()
SeedRnd MilliSecs():Global timer=CreateTimer(60)
Global lemaddwait,lemaddtimer,maxlem,numlem,tosave,saved,dead,nuked,mins,secs
Global level,level_image,small_level,home,selected,gamespeed,mouse_image,paused
Global xoffset,yoffset,oldxoffset,oldyoffset,tex$
Global numfrags,channel,seconds#,oldseconds# 
; dims
Dim td(10),buttons(13,4),map(307,32),info$(10),in#(5),out#(5)
For d=0 To 8
   Read t$
   info$(d)=t$
Next
Data "Walker","Climber","Floater","Blocker","Builder","Basher","Miner","Digger","Athlete"
For dat=1 To 13
   Read a,b,c,d
   buttons(dat,1)=a:buttons(dat,2)=b:buttons(dat,3)=c:buttons(dat,4)=d
Next
Data 4,423,1,0,49,423,0,0,94,423,0,0,139,423,0,0,184,423,0,0,229,423,0,0,274,423,0,0
Data 319,423,0,0,364,423,0,0,409,423,0,0,454,423,0,0,499,423,0,0,544,423,0,0
; fonts
Global font1=LoadFont("Fonts\Default.fon",18,1,0)
Global font2=LoadFont("Fonts\Default.fon",24,1,0)
SetFont font1
; sounds
Global die1=LoadSound("Sfx\Splat.wav")
Global die2=LoadSound("Sfx\Die.wav")
Global die3=LoadSound("Sfx\Ohno.wav")
Global pop=LoadSound("Sfx\Explode.wav")
Global click1=LoadSound("Sfx\Changeop.wav")
Global click2=LoadSound("Sfx\Mousepre.wav")
Global last3=LoadSound("Sfx\Ting.wav")
Global door=LoadSound("Sfx\Door.wav")
Global letsgo=LoadSound("Sfx\Letsgo.wav")
Global yippee=LoadSound("Sfx\Yippee.wav")
; graphics
Global lemlogo=LoadImage("Gfx\lemlogo.png")
Global logo=LoadImage("Gfx\logo.png")
Global splash1=LoadImage("Gfx\splash1.png")
Global splash2=LoadImage("Gfx\splash2.png")
Global entrance=LoadAnimImage("Gfx\entrance.png",82,52,0,9)
Global box_image=LoadImage("Gfx\box0.png")
Global box_cursor=LoadImage("Gfx\box1.png")
Global box_icon=LoadImage("Gfx\box2.png")
Global icons=LoadImage("Gfx\icons.png")
Global mouse=LoadAnimImage("Gfx\mouse.png",28,28,0,3)
Global sprites=LoadAnimImage("Gfx\sprites.png",64,32,0,320)
Global masks1=LoadAnimImage("Gfx\masks1.png",10,18,0,8):MaskImage masks1,255,0,255
Global masks2=LoadAnimImage("Gfx\masks2.png",16,26,0,4):MaskImage masks2,255,0,255
Global masks3=LoadImage("Gfx\masks3.png"):MaskImage masks3,255,0,255
; types
Type lemming ; the lemmings
    Field x#,y#,sx#,sy#,dir,flag0,flag1,flag2,image#,bimage#,mimage#,frame#,framerate#,maxframe,job
    Field state,bstate,planks,walker,climber,floater,bomber,blocker,builder,basher,miner,digger
End Type
Type Frag    ; nukes fragments
	Field x#,y#,xs#,ys#,an#
End Type
;
level=0 ; starting level (0 - 10)
;
movie=OpenMovie("Gfx/Psygnosis.mpg") 
w=MovieWidth(movie) 
h=MovieHeight(movie) 
;  
x=(width-w)/2 
y=(height-h-100)/2 
period=5000  
time=MilliSecs() 
Repeat 
Cls                         
DrawMovie movie,x,y,w,h    
Flip
Until MilliSecs()-time>=period 
; 
splashscreen() ; main screen
; game loop starts here?
.start_the_game
loadlevel()
randommusic()
gameon=False:chan0=0:chan1=0
MoveMouse width/2,height/2
FlushMouse
;
; the main loop
;
While Not KeyDown(1)
WaitTimer(timer)
Cls
mx=MouseX():my=MouseY():md=MouseDown(1):mh=MouseHit(1)
updategame(mx,my,md,mh)
If in(3)=False And lemaddtimer+1000<MilliSecs() 
  If chan0=0 chan0=PlaySound(door):chan1=PlaySound(letsgo)
    in(2)=in(2)+0.1
    If in(2)>8 in(2)=8:in(3)=True:lemaddtimer=lemaddwait
  Else
    addlemming()
  EndIf
For s=0 To gamespeed
   update_lemmings()
   updatefrags()
   updatetimer()
Next 
render_lemmings()
check_mouse(mx,my,md,mh)
;DrawImage home,mx,my,0
;DrawImage entrance,mx,my,0
If KeyHit(31)
  If FileType("Capture"+file+".bmp")=1
    Repeat
     file=file+1
    Until FileType("Capture"+file+".bmp")=0
  EndIf 
  SaveBuffer(BackBuffer(),"Capture"+file+".bmp")
EndIf
; scroll
If mx<1 xoffset=xoffset+2:If xoffset>0 xoffset=0
If mx>width-29 xoffset=xoffset-2:If xoffset<-2234 xoffset=-2234
; small level scroll
If RectsOverlap(mx,my,1,1,247,515,ImageWidth(box_image),ImageHeight(box_image)) And md=True
  xoffset=xoffset-MouseXSpeed()*10
  If xoffset>0 xoffset=0
  If xoffset<-2234 xoffset=-2234
EndIf
;
If saved=maxlem Or saved+dead=maxlem Or mins+secs=0 And numfrags=0  
  For l.lemming=Each lemming
     Delete l
  Next
  StopChannel channel
  results()
  gameon=True
  Exit
EndIf
Flip
Wend
; stop the music
StopChannel channel
Delay 1000
If gameon=True Goto start_the_game
gfxbank=GrabBank() 
For i=1 To 8 
    Fade(gfxbank) 
    Flip 
Next 
FreeBank gfxbank 
endgame()
;
; update lemmings
;
Function update_lemmings()
If paused=True Return
For l.lemming=Each lemming ; loop thru all lemmings
If l\x>0 And l\x<ImageWidth(level_image) And l\y>0 And l\y<ImageHeight(level_image)-1
  If paused=False l\frame=l\frame+l\framerate:If l\frame>l\maxframe l\frame=0:l\flag0=True
Else
  chan=PlaySound(die2)
  If l\job=6 Or l\job=7
    SetBuffer ImageBuffer(level_image)
    Color 0,0,0:Rect l\x-8,l\y-3,17,10,1
    fullview(l.lemming,2,2,1,1,0,0,0)
    SetBuffer BackBuffer()
  EndIf
  dead=dead+1:out(3)=out(3)-1:Delete l:Exit 
EndIf
Select l\job
      Case 0 ; walker
          If l\flag2=False walker(l.lemming)
          If l\bomber=True bomber(l.lemming)
      Case 1 ; climber
          climber(l.lemming):If l\bomber=True bomber(l.lemming)
      Case 2 ; floater
          floater(l.lemming):If l\bomber=True bomber(l.lemming)
      Case 3 ; blocker
          blocker(l.lemming):If l\bomber=True bomber(l.lemming) 
      Case 4 ; builder
          If l\dir=0 And l\flag2=False buildleft(l.lemming)
          If l\dir=1 And l\flag2=False buildright(l.lemming)
          If l\bomber=True bomber(l.lemming) 
      Case 5 ; basher
          If l\dir=0 And l\flag2=False bashleft(l.lemming)
          If l\dir=1 And l\flag2=False bashright(l.lemming)
          If l\bomber=True bomber(l.lemming) 
      Case 6 ; miner
          If l\dir=0 And l\flag2=False mineleft(l.lemming)
          If l\dir=1 And l\flag2=False mineright(l.lemming)
          If l\bomber=True bomber(l.lemming) 
      Case 7 ; digger
          If l\flag2=False digger(l.lemming)
          If l\bomber=True bomber(l.lemming)
      Case 8 ; saved yippee
          saved(l.lemming)
      Case 9 ; fell to far (splat)
          splat(l.lemming)
End Select
Next
End Function
;
; walker
;
Function walker(l.lemming)
l\framerate=0.2:l\maxframe=7
; Activate the level buffer
SetBuffer ImageBuffer(level_image)
LockBuffer ImageBuffer(level_image)
; Read the surrounding area of the lemming to the left
p=ReadPixelFast(l\x-1,l\y-1) And $FFFFFF
If p Then td(0)=1 Else td(0)=0
p=ReadPixelFast(l\x-1,l\y) And $FFFFFF
If p Then td(3)=1 Else td(3)=0
p=ReadPixelFast(l\x,l\y-8) And $FFFFFF
If p Then td(1)=1 Else td(1)=0
; to the Right
p=ReadPixelFast(l\x+1,l\y-1) And $FFFFFF
If p Then td(2)=1 Else td(2)=0
p=ReadPixelFast(l\x+1,l\y) And $FFFFFF
If p Then td(4)=1 Else td(4)=0
p=ReadPixelFast(l\x+1,l\y-8) And $FFFFFF
If p Then td(5)=1 Else td(5)=0
; check below
p=ReadPixelFast(l\x,l\y+1) And $FFFFFF
If p Then td(6)=1 Else td(6)=0
; check below further
p=ReadPixelFast(l\x,l\y+3) And $FFFFFF
If p Then td(7)=1 Else td(7)=0
; check below even further
p=ReadPixelFast(l\x,l\y+5) And $FFFFFF
If p Then td(8)=1 Else td(8)=0
; restore the backbuffer
UnlockBuffer ImageBuffer(level_image)
SetBuffer BackBuffer() 
; If a lemming is in the air then move that lemming one space down
If td(6)=0 
  If l\floater=True And (td(7)=0 And td(8)=0) ; floater
    If td(7)=0 
      l\flag1=0:l\frame=0:l\state=0:l\job=2 
    Else
      l\flag1=l\flag1+1:l\y=l\y+1
    EndIf
  Else
    l\flag1=l\flag1+1:l\y=l\y+1
  EndIf
EndIf
If td(7)=0
  l\maxframe=3:If l\dir=0 l\image=20 Else l\image=16
  If l\frame>l\maxframe l\frame=0
EndIf
If td(6)=1 And l\flag1>140 l\frame=0:l\flag0=0:l\job=9:chan=PlaySound(die1)
; if we are moving to the right and is there a floor underneath the lemming
vx=l\x/10:vy=l\y/10
If map(vx+1,vy)=1 ; check for a blocker
  l\dir=0:l\image=8 
Else
  If l\dir=1 And td(6)=1 
    l\image=0:l\flag1=0
    If td(2)=0 Or td(5)=0 ; If it is not to high
      If td(4)=1 ; is it higher
        l\y=l\y-1 ; go up a bit
      End If
      If td(4)=1 And td(5)=1
        If l\climber=True
          l\frame=0:l\job=1
        Else
          l\dir=0:l\image=8:l\x=l\x-0.5
        EndIf
      End If 
      l\x=l\x+0.5 ; move to the right
    Else
      If l\climber=True
        l\frame=0:l\state=0:l\job=1
      Else
        l\dir=0:l\image=8 ; if we cannot move any further then change direction
      EndIf
    End If
  End If
EndIf
; if we are moving to the left and is there a floor beneath the lemming
If map(vx-1,vy)=1 ; check for a blocker
  l\dir=1:l\image=0 
Else
  If l\dir=0 And td(6)=1  
    l\image=8:l\flag1=0
    If td(0)=0 Or td(1)=0 ; if it is not to high
      If td(3)=1 ; is it higher
        l\y=l\y-1 ; move up a bit
      End If
      If td(1)=1 And td(3)=1
        If l\climber=True
          l\frame=0:l\state=0:l\job=1
        Else
          l\dir=1:l\image=0:l\x=l\x+0.5
        EndIf 
      End If
        l\x=l\x-0.5 ; move to the left
      Else
        If l\climber=True
          l\frame=0:l\job=1
        Else
          l\dir=1:l\image=0 ; if we cannot move further then change direction
        EndIf
     End If
  End If
EndIf
; check for exit
tx=Abs(oldxoffset)+xoffset+out(0):ty=out(1)
If RectsOverlap(tx+36,ty+40,4,4,xoffset+l\x-6,yoffset+l\y-8,1,1)
  l\flag0=0:l\frame=0:l\state=0:l\job=8:PlaySound yippee
EndIf
End Function
;
; climber
;
Function climber(l.lemming)
Select l\state
Case 0 ; climbing
l\framerate=0.2:l\maxframe=7
; Activate the level buffer
SetBuffer ImageBuffer(level_image)
LockBuffer ImageBuffer(level_image)
If l\dir=1 ; facing right
  l\image=24
  p=ReadPixelFast(l\x-1,l\y-20) And $FFFFFF
  If p Then td(0)=1 Else td(0)=0
  p=ReadPixelFast(l\x+1,l\y-15) And $FFFFFF
  If p Then td(1)=1 Else td(1)=0
  p=ReadPixelFast(l\x-1,l\y-10) And $FFFFFF
  If p Then td(2)=1 Else td(2)=0
Else ; facing left
  l\image=32
  p=ReadPixelFast(l\x+1,l\y-20) And $FFFFFF
  If p Then td(0)=1 Else td(0)=0
  p=ReadPixelFast(l\x-1,l\y-15) And $FFFFFF
  If p Then td(1)=1 Else td(1)=0
  p=ReadPixelFast(l\x+1,l\y-10) And $FFFFFF
  If p Then td(2)=1 Else td(2)=0
EndIf

; restore the backbuffer
UnlockBuffer ImageBuffer(level_image)
SetBuffer BackBuffer() 
 
If l\dir=1 And td(1)=0 ; reached the top 
  l\flag0=False:l\y=l\y-4
  l\image=40:l\frame=0:l\framerate=0.2:l\maxframe=7:l\state=1
  Return
End If
If l\dir=0 And td(1)=0 ; reached the top
  l\flag0=False:l\y=l\y-4
  l\image=48:l\frame=0:l\framerate=0.2:l\maxframe=7:l\state=1
  Return
End If

If td(0)=0 And td(2)=0
  l\y=l\y-0.2
Else
  l\framerate=0.2:l\frame=0:l\state=0:l\job=0
  If l\dir=0 
    l\dir=1:l\image=0:l\x=l\x+4 
  Else
    l\dir=0 l\image=8:l\x=l\x-4
  EndIf
End If
Case 1 ; flipping
If l\flag0=True
  l\flag0=False:l\state=0:l\frame=0:l\job=0:l\y=l\y-8
  If l\dir=0 l\x=l\x-4:l\image=8 Else l\x=l\x+4:l\image=0
EndIf
End Select
End Function
;
; floater
;
Function floater(l.lemming)
l\flag1=l\flag1+1
; Activate the level buffer
SetBuffer ImageBuffer(level_image)
LockBuffer ImageBuffer(level_image)
; check below
p=ReadPixelFast(l\x,l\y+1) And $FFFFFF
If p Then td(0)=1 Else td(0)=0
; restore the backbuffer
UnlockBuffer ImageBuffer(level_image)
SetBuffer BackBuffer() 
;
Select l\state
Case 0 ; fall so far then open brolly
    If td(0)=0
      l\y=l\y+1
      If l\flag1>50
        If l\dir=0 l\image=66 Else l\image=56
        l\flag0=False:l\flag1=0:l\frame=0:l\framerate=0.1:l\maxframe=3:l\state=1
      EndIf
    Else
      l\state=0:l\frame=0:l\job=0:l\flag0=0:l\flag1=0
      If l\dir=0 l\image=0 Else l\image=8
    EndIf
Case 1 ; open brolly
    If td(0)=0
      l\y=l\y+0.5
    Else
      l\state=0:l\frame=0:l\job=0:l\flag0=0:l\flag1=0
      If l\dir=0 l\image=0:l\x=l\x-10 Else l\image=8:l\x=l\x+10
    EndIf
    If l\flag0=True And l\state=1
      l\frame=0:l\framerate=0.1:l\maxframe=5:l\state=2
      If l\dir=0 l\image=70 Else l\image=60
    EndIf
Case 2 ; float down
    If td(0)=0
      l\y=l\y+0.5
    Else
      l\state=0:l\frame=0:l\job=0:l\flag0=0:l\flag1=0
      If l\dir=0 l\image=0 Else l\image=8
    EndIf
End Select
End Function
;
; bomber
;
Function bomber(l.lemming)
Select l\bstate
Case 0 ; count down
    l\bimage=l\bimage+0.01
    If Int(l\bimage)=113
      If l\job=1 Or l\job=2
        l\bstate=2
      Else
        chan=PlaySound(die3)
        vx=l\x/10:vy=l\y/10
        If map(vx,vy)=1 map(vx,vy)=0 ; a blocker
        l\image=76:l\framerate=0.2:l\maxframe=15
        l\flag0=False:l\flag2=True:l\bstate=1
        If l\digger=True l\y=l\y-4
      EndIf
    EndIf
Case 1 ; on no!
    SetBuffer ImageBuffer(level_image)
    LockBuffer ImageBuffer(level_image)
    ; check below
    p=ReadPixelFast(l\x,l\y+1) And $FFFFFF
    If p Then td(6)=1 Else td(6)=0
    UnlockBuffer ImageBuffer(level_image)
    SetBuffer BackBuffer() 
    If td(6)=0 l\y=l\y+1
    If l\flag0=True l\bstate=2
Case 2 ; boom    
      n=Rnd(20)+20
      anstep#=60.0/n:tx#=l\x:ty#=l\y+8
      an#=Rnd(anstep):xpos=tx#:ypos=ty#
      chan=PlaySound(pop)
      SetBuffer ImageBuffer(level_image)
      DrawImage masks3,l\x-16,l\y-30
      fullview(l.lemming,4,5,2,2,0,0,0)
      SetBuffer BackBuffer() 
      ; make new fragments
      For y=0 To 15
      For x=0 To 15
        f.frag=New frag
        f\x=xpos:f\y=ypos:xpos=xpos+1:numfrags=numfrags+1
        f\xs=Sin(an)*Rnd(0,2)
        f\ys=Cos(an)*Rnd(0,4)
        an=an+anstep
      Next
        ypos=ypos+1:xpos=tx#
      Next
      dead=dead+1:out(3)=out(3)-1:Delete l
End Select
End Function
;
; blocker
;
Function blocker(l.lemming)
If l\flag2=False
  l\image=114:l\framerate=0.1:l\maxframe=11
  ; Activate the level buffer
  SetBuffer ImageBuffer(level_image)
  LockBuffer ImageBuffer(level_image)
  ; check below the lemming
  p=ReadPixelFast(l\x,l\y+3) And $FFFFFF
  If p Then td(0)=1 Else td(0)=0
  ; restore the backbuffer
  UnlockBuffer ImageBuffer(level_image)
  SetBuffer BackBuffer() 
  If td(0)=0
    l\blocker=False:l\frame=0:l\job=0
    vx=l\x/10:vy=l\y/10
    If map(vx,vy)=1 map(vx,vy)=0 ; remove block flag
  EndIf
EndIf
End Function
;
; build left
;
Function buildleft(l.lemming)
Select l\state
      Case 0 ; getting plank from sack
          l\image=151:l\framerate=0.2:l\maxframe=3
          If l\flag0=True l\flag0=0:l\state=1

      Case 1 ; laying plank
          ; Activate the level buffer
          SetBuffer ImageBuffer(level_image)
          DrawImage sprites,l\x-8,l\y-31,142
          LockBuffer ImageBuffer(level_image)
          p=ReadPixelFast(l\x-4,l\y-2) And $FFFFFF
          If p Then td(0)=1 Else td(0)=0
          p=ReadPixelFast(l\x,l\y-20) And $FFFFFF
          If p Then td(1)=1 Else td(1)=0
          If l\planks>8 chan=PlaySound(last3) 
          l\image=155:l\framerate=0.1:l\maxframe=7
          l\flag0=0:l\state=2
          ; restore the backbuffer
          UnlockBuffer ImageBuffer(level_image)
          fullview(l.lemming,1,1,0,1,255,255,255)
          SetBuffer BackBuffer() 
          If td(0)=1 Or td(1)=1 ; hit something
             If l\dir=0 l\dir=1:l\image=8 Else l\dir=1:l\image=0
             l\job=0:l\builder=False:l\planks=0:l\state=0
          EndIf 

      Case 2 ; new plank laid
          If l\flag0=True
            l\x=l\x-4:l\y=l\y-2:l\planks=l\planks+1
            l\image=163:l\framerate=0.2:l\maxframe=3
            l\flag0=0:l\state=3
            If l\planks=12
              l\planks=0:l\image=167:l\framerate=0.2:l\maxframe=7:l\state=4
            EndIf
          EndIf

      Case 3 ; getting ready to lay next plank 
          If l\flag0=True
            l\flag0=0:l\state=0
          EndIf

      Case 4 ; ran out of planks
          If l\flag0=True l\state=0:l\builder=False:l\job=0
          mx=MouseX():my=MouseY():md=MouseDown(1):mh=MouseHit(1):lx=l\x+xoffset:ly=l\y+yoffset
          If RectsOverlap(lx,ly,1,1,mx,my+14,28,28) And md=True And paused=False
            If buttons(5,4)>0
              l\builder=True:l\basher=False:l\miner=False:l\digger=False:l\planks=0
              l\flag0=0:l\frame=0:l\state=0:l\job=4:buttons(5,4)=buttons(5,4)-1:PlaySound click2
            EndIf
          EndIf 
End Select
End Function
;
; build right
;
Function buildright(l.lemming)
Select l\state
      Case 0 ; getting plank from sack
          l\image=126:l\framerate=0.2:l\maxframe=3
          If l\flag0=True l\flag0=0:l\state=1

      Case 1 ; laying plank
          ; Activate the level buffer
          SetBuffer ImageBuffer(level_image)
          DrawImage sprites,l\x-4,l\y-31,142
          LockBuffer ImageBuffer(level_image)
          p=ReadPixelFast(l\x+4,l\y-2) And $FFFFFF
          If p Then td(0)=1 Else td(0)=0
          p=ReadPixelFast(l\x,l\y-20) And $FFFFFF
          If p Then td(1)=1 Else td(1)=0
          If l\planks>8 chan=PlaySound(last3) 
          l\image=130:l\framerate=0.1:l\maxframe=7
          l\flag0=False:l\state=2
          ; restore the backbuffer
          UnlockBuffer ImageBuffer(level_image)
          fullview(l.lemming,1,1,0,1,255,255,255)
          SetBuffer BackBuffer() 
          If td(0)=1 Or td(1)=1 ; hit something
             If l\dir=0 l\dir=1:l\image=8 Else l\dir=1:l\image=0
             l\job=0:l\builder=False:l\planks=0:l\state=0
          EndIf 

      Case 2 ; new plank laid
          If l\flag0=True
            l\x=l\x+4:l\y=l\y-2:l\planks=l\planks+1
            l\image=138:l\framerate=0.2:l\maxframe=3
            l\flag0=0:l\state=3
            If l\planks=12
              l\planks=0:l\image=143:l\framerate=0.2:l\maxframe=7:l\state=4
            EndIf
          EndIf

      Case 3 ; getting ready to lay next plank 
          If l\flag0=True
            l\flag0=False:l\state=0
          EndIf

      Case 4 ; ran out of planks
          If l\flag0=True l\state=0:l\builder=False:l\job=0
          mx=MouseX():my=MouseY():md=MouseDown(1):mh=MouseHit(1):lx=l\x+xoffset:ly=l\y+yoffset
          If RectsOverlap(lx,ly,1,1,mx,my+14,28,28) And md=True And paused=False
            If buttons(5,4)>0
              l\builder=True:l\basher=False:l\miner=False:l\digger=False:l\planks=0
              l\flag0=0:l\frame=0:l\state=0:l\job=4:buttons(5,4)=buttons(5,4)-1:PlaySound click2
            EndIf
          EndIf          
End Select
End Function
;
; bash left
;
Function bashleft(l.lemming)
Select l\state
      Case 0
          l\image=205:l\framerate=0.3:l\maxframe=14
          SetBuffer ImageBuffer(level_image)
          LockBuffer ImageBuffer(level_image)
          ; check if there's something to bash
          p=ReadPixelFast(l\x-8,l\y-6) And $FFFFFF
          If p td(0)=1 Else td(0)=0
          ; check below
          p=ReadPixelFast(l\x,l\y+1) And $FFFFFF
          If p td(1)=1 Else td(1)=0
          ; check below further
          p=ReadPixelFast(l\x,l\y+3) And $FFFFFF
          If p Then td(2)=1 Else td(2)=0
          UnlockBuffer ImageBuffer(level_image)
          ; draw the mask
          DrawImage masks1,l\x-4,l\y-17,4+l\mimage
          fullview(l.lemming,2,2,1,1,0,0,0)
          SetBuffer BackBuffer() 
          If Int(l\frame)>2 And Int(l\frame)<7
            l\mimage=l\mimage+1:If l\mimage>3 l\mimage=0
          EndIf
          If td(1)=0 l\y=l\y+1
          If td(2)=0 l\flag0=True:td(0)=0
          If l\flag0=True
            If td(0)=0 
              l\basher=False:l\state=0:l\job=0
            Else
              l\flag0=False l\state=1:l\x=l\x-5.5
            EndIf
          EndIf

      Case 1
          l\image=220:l\framerate=0.3:l\maxframe=14
          SetBuffer ImageBuffer(level_image)
          DrawImage masks1,l\x-4,l\y-17,4+l\mimage
          SetBuffer BackBuffer() 
          If Int(l\frame)>2 And Int(l\frame)<7
            l\mimage=l\mimage+1:If l\mimage>3 l\mimage=0
          EndIf
          If l\flag0=True l\flag0=False l\state=0:l\x=l\x-5.5
End Select
End Function
;
; bash right
;
Function bashright(l.lemming)
Select l\state
      Case 0
          l\image=175:l\framerate=0.3:l\maxframe=14
          SetBuffer ImageBuffer(level_image)
          LockBuffer ImageBuffer(level_image)
          ; check if there's something to bash
          p=ReadPixelFast(l\x+8,l\y-6) And $FFFFFF
          If p td(0)=1 Else td(0)=0
          ; check below
          p=ReadPixelFast(l\x,l\y+1) And $FFFFFF
          If p td(1)=1 Else td(1)=0
          ; check below further
          p=ReadPixelFast(l\x,l\y+3) And $FFFFFF
          If p Then td(2)=1 Else td(2)=0
          UnlockBuffer ImageBuffer(level_image)
          ; draw the mask
          DrawImage masks1,l\x-2,l\y-17,l\mimage
          fullview(l.lemming,2,2,1,1,0,0,0)
          SetBuffer BackBuffer() 
          If Int(l\frame)>2 And Int(l\frame)<7
            l\mimage=l\mimage+1:If l\mimage>3 l\mimage=0
          EndIf
          If td(1)=0 l\y=l\y+1
          If td(2)=0 l\flag0=True:td(0)=0
          If l\flag0=True
            If td(0)=0 
              l\basher=False:l\state=0:l\job=0
            Else
              l\flag0=False l\state=1:l\x=l\x+5.5
            EndIf
          EndIf
           
      Case 1
          l\image=190:l\framerate=0.3:l\maxframe=14
          SetBuffer ImageBuffer(level_image)
          DrawImage masks1,l\x-2,l\y-17,l\mimage
          SetBuffer BackBuffer() 
          If Int(l\frame)>2 And Int(l\frame)<7
            l\mimage=l\mimage+1:If l\mimage>3 l\mimage=0
          EndIf
          If l\flag0=True l\flag0=False l\state=0:l\x=l\x+5.5
End Select
End Function
;
; mine left
;
Function mineleft(l.lemming)
Select l\state
      Case 0
          l\image=259:l\framerate=0.3:l\maxframe=3
          If l\flag0=True
            ; dig the dirt
            SetBuffer ImageBuffer(level_image)
            DrawImage masks2,l\x-15,l\y-24,1
            LockBuffer ImageBuffer(level_image)
            ; check if there's something to mine
            p=ReadPixelFast(l\x-10,l\y) And $FFFFFF
            If p td(0)=1 Else td(0)=0
            ; check below
            p=ReadPixelFast(l\x-10,l\y+2) And $FFFFFF
            If p td(1)=1 Else td(1)=0
            ; check below further
            p=ReadPixelFast(l\x,l\y+2) And $FFFFFF
            If p Then td(2)=1 Else td(2)=0
            UnlockBuffer ImageBuffer(level_image)
            fullview(l.lemming,2,2,1,1,0,0,0)
            SetBuffer BackBuffer()
            If td(0)=0 And td(1)=0
              l\state=0:l\frame=0:l\flag0=0:l\job=0:l\miner=False
              l\x=l\x-4:l\y=l\y+2:Return
            EndIf
            l\x=l\x-4:l\y=l\y+2
            l\image=262:l\maxframe=15:l\state=1:l\frame=0:l\flag0=0
          EndIf
      Case 1
          If l\flag0=True l\image=277:l\maxframe=5:l\state=2:l\flag0=0
      Case 2
          If l\flag0=True l\state=0:l\frame=0:l\flag0=0
End Select
End Function
;
; mine right
;
Function mineright(l.lemming)
Select l\state
      Case 0
          l\image=235:l\framerate=0.3:l\maxframe=3
          If l\flag0=True
            ; dig the dirt
            SetBuffer ImageBuffer(level_image)
            DrawImage masks2,l\x,l\y-24,3
            LockBuffer ImageBuffer(level_image)
            ; check if there's something to mine
            p=ReadPixelFast(l\x+10,l\y) And $FFFFFF
            If p td(0)=1 Else td(0)=0
            ; check below
            p=ReadPixelFast(l\x+10,l\y+2) And $FFFFFF
            If p td(1)=1 Else td(1)=0
            ; check below further
            p=ReadPixelFast(l\x,l\y+2) And $FFFFFF
            If p Then td(2)=1 Else td(2)=0
            UnlockBuffer ImageBuffer(level_image)
            fullview(l.lemming,2,2,1,1,0,0,0)
            SetBuffer BackBuffer()
            If td(0)=0 And td(1)=0
              l\state=0:l\frame=0:l\flag0=0:l\job=0:l\miner=False
              l\x=l\x+4:l\y=l\y+2:Return
            EndIf
            l\x=l\x+4:l\y=l\y+2
            l\image=238:l\maxframe=15:l\state=1:l\frame=0:l\flag0=0
          EndIf
      Case 1
          If l\flag0=True l\image=253:l\maxframe=5:l\state=2:l\flag0=0
      Case 2
          If l\flag0=True l\state=0:l\frame=0:l\flag0=0
End Select
End Function
;
; digger
;
Function digger(l.lemming)
; check to see if theres anything to dig
SetBuffer ImageBuffer(level_image)
p=ReadPixelFast(l\x,l\y) And $FFFFFF
If p Then td(0)=1 Else td(0)=0
;
If td(0)=0
  l\digger=False:l\state=0:l\job=0
  Color 0,0,0:Rect l\x-8,l\y-4,17,12,1
  fullview(l.lemming,2,2,1,1,0,0,0)
EndIf 
SetBuffer BackBuffer()
;
Select l\state
      Case 0
          l\image=283:l\framerate=0.2:l\maxframe=7
          If l\flag0=True
            SetBuffer ImageBuffer(level_image)
            Color 0,0,0:Rect l\x-8,l\y-7,17,6,1
            fullview(l.lemming,2,2,1,1,0,0,0)
            SetBuffer BackBuffer()
            l\y=l\y+2:l\image=291
            l\frame=0:l\flag0=0:l\state=1
          EndIf
      Case 1
          If l\flag0=True
            SetBuffer ImageBuffer(level_image)
            Color 0,0,0:Rect l\x-8,l\y-7,17,6,1
            fullview(l.lemming,2,2,1,1,0,0,0)
            SetBuffer BackBuffer()
            l\y=l\y+2:l\image=283:l\frame=0:l\flag0=0:l\state=0
          EndIf
End Select
End Function
;
; saved yippee
;
Function saved(l.lemming)
l\image=300:l\framerate=0.2:l\maxframe=5
If l\flag0=True
  saved=saved+1:out(3)=out(3)-1:Delete l
EndIf
End Function
;
; splat fell to far dead lemming
;
Function splat(l.lemming)
l\image=92:l\framerate=0.2:l\maxframe=15
If l\flag0=True
  dead=dead+1:out(3)=out(3)-1:Delete l
EndIf
End Function
;
; play random music
;
Function randommusic()
If Not ChannelPlaying(channel)
  m=Rnd(1,15):s$="Music\"+Str$(m)+".mid" 
  channel=PlayMusic(s$)
EndIf
End Function
;
; splash screen
;
Function splashscreen()
Cls
DrawBlock lemlogo,width/2-ImageWidth(lemlogo)/2,height/2-ImageHeight(lemlogo)/2
Flip
Delay 3000 
SetFont font2
channel=PlayMusic("Music\lemmings.mp3")
While Not MouseHit(1)
mx=MouseX():my=MouseY()
k=KeyDown(1): If k=True Exit
Cls
DrawImage splash1,0,0
Color 0,0,0
Text tx+235,ty+510,"LEFT MOUSE BUTTON TO PLAY."
Text tx+140,ty+540,"(HIT ESCAPE AT ANY TIME TO QUIT TO WINDOWS)"
Color 255,255,0
Text tx+236,ty+512,"LEFT MOUSE BUTTON TO PLAY."
Text tx+141,ty+542,"(HIT ESCAPE AT ANY TIME TO QUIT TO WINDOWS)"
DrawImage mouse,mx,my,2
Flip
Wend
StopChannel channel
gfxbank=GrabBank() 
For i=1 To 8 
    Fade(gfxbank) 
    Flip 
Next 
FreeBank gfxbank 
FreeImage lemlogo:FreeImage splash1
If k=True endgame
End Function
;
; results
;
Function results()
gfxbank=GrabBank() 
For i=1 To 8 
    Fade(gfxbank) 
    Flip 
Next 
FreeBank gfxbank 
While Not MouseHit(1)
mx=MouseX():my=MouseY()
k=KeyDown(1): If k=True Exit
Cls
TileImage logo,0,0
tx=width/2-ImageWidth(splash2)/2:ty=20
DrawImage splash2,tx,ty
SetFont font2
Color 0,0,0:Text tx+180,ty+100,"All lemmings accounted for"
Color 255,255,0:Text tx+181,ty+102,"All lemmings accounted for"
SetFont font1
Color 0,0,0:Text tx+240,ty+130,"You needed "+tosave+""
Color 255,255,0:Text tx+241,ty+132,"You needed "+tosave+""
Color 0,0,0:Text tx+240,ty+150,"You rescued "+saved+""
Color 255,255,0:Text tx+241,ty+152,"You rescued "+saved+""
;
If mins+secs=0 And saved<tosave And saved<>maxlem
  Color 0,0,0:Text tx+160,ty+180,"OUT OF TIME!   You had better be a bit"
  Color 255,255,0:Text tx+161,ty+182,"OUT OF TIME!   You had better be a bit"
  Color 0,0,0:Text tx+160,ty+200,"quicker. If you want to save the lemmings!"
  Color 255,255,0:Text tx+161,ty+202,"quicker. If you want to save the lemmings!"
Else
If saved=0
  Color 0,0,0:Text tx+160,ty+180,"ROCK BOTTOM!   I hope for your sake"
  Color 255,255,0:Text tx+161,ty+182,"ROCK BOTTOM!   I hope for your sake"
  Color 0,0,0:Text tx+160,ty+200,"That you nuked that level."
  Color 255,255,0:Text tx+161,ty+202,"That you nuked that level."
Else
  If saved=maxlem
    Color 0,0,0:Text tx+160,ty+180,"SUPERB!  You rescued every lemming on"
    Color 255,255,0:Text tx+161,ty+182,"SUPERB!  You rescued every lemming on"
    Color 0,0,0:Text tx+160,ty+200,"that level. Can you do it again....?"
    Color 255,255,0:Text tx+161,ty+202,"that level. Can you do it again....?"
Else
  If saved<tosave
    Color 0,0,0:Text tx+160,ty+180,"BETTER!  Rethink your strategy before"
    Color 255,255,0:Text tx+161,ty+182,"BETTER!  Rethink your strategy before"
    Color 0,0,0:Text tx+160,ty+200,"You try this level again!"
    Color 255,255,0:Text tx+161,ty+202,"You try this level again!" 
Else
  If saved=tosave
    Color 0,0,0:Text tx+160,ty+180,"RIGHT ON.  You cant't get much closer"
    Color 255,255,0:Text tx+161,ty+182,"RIGHT ON.  You cant't get much closer"
    Color 0,0,0:Text tx+160,ty+200,"than that.  Let's try the next...."
    Color 255,255,0:Text tx+161,ty+202,"than that.  Let's try the next...." 
  Else
    Color 0,0,0:Text tx+160,ty+180,"That level seemed no problem to you on"
    Color 255,255,0:Text tx+161,ty+182,"That level seemed no problem to you on"
    Color 0,0,0:Text tx+160,ty+200,"that attempt.  Onto the next...."
    Color 255,255,0:Text tx+161,ty+202,"that attempt.  Onto the next...." 
  EndIf
EndIf
EndIf
EndIf
EndIf
SetFont font2
Color 0,0,0:Text tx+115,ty+350,"LEFT MOUSE BUTTON TO CONTINUE?"
Color 255,255,0:Text tx+116,ty+352,"LEFT MOUSE BUTTON TO CONTINUE?"
DrawImage mouse,mx,my,2
Flip
Wend
SetFont font1
If saved>=tosave level=level+1:If level>10 level=0
gfxbank=GrabBank() 
For i=1 To 8 
    Fade(gfxbank) 
    Flip 
Next 
FreeBank gfxbank 
Cls:Flip
If k=True endgame
End Function
;
; load level
;
Function loadlevel()
numfrags=0:nuked=False:gamespeed=0:mouse_image=0:selected=1
; clear the map
For y=0 To 31
   For x=0 To 306
      map(x,y)=0
   Next
Next
For dat=1 To 13
   buttons(dat,3)=0:buttons(dat,4)=0
Next
buttons(1,3)=selected
; load the level
FreeImage level_image:FreeImage small_level:FreeImage home
l$="Levels\Lv"+Str$(level)+".png"
level_image=LoadImage(l$)
small_level=CopyImage(level_image):ResizeImage small_level,307,64 
; Open the file to Read
f$="Levels\Lv"+Str$(level)+".dat"
filein=ReadFile(f$)
; title
t$=ReadLine$(filein)
; exit image
l$=ReadLine$(filein)
home=LoadAnimImage(l$,82,52,0,4)
; mask
l$=ReadLine$(filein)
temp=LoadImage(l$):MaskImage temp,255,0,255
;
xoffset=ReadLine$(filein):yoffset=ReadLine$(filein) ; position of level on screen
oldxoffset=xoffset:oldyoffset=yoffset
in(0)=ReadLine$(filein):in(1)=ReadLine$(filein)     ; trapdoor position on screen
in(2)=0:in(3)=0
out(0)=ReadLine$(filein):out(1)=ReadLine$(filein)   ; exit position on screen
out(2)=0:out(3)=0
; number of workers per job
For dat=1 To 10
   buttons(dat,4)=ReadLine$(filein)
Next
lemaddwait=buttons(9,4)*100:numlem=0:saved=0:dead=0
maxlem=ReadLine$(filein)     ; number of lemming for this level
tosave=ReadLine$(filein)     ; lemming to save
mins=ReadLine$(filein)       ; the time to complete the level (minutes)
secs=ReadLine$(filein)       ; the time to complete the level (seconds)
; Close the file once reading is finished
CloseFile(filein)
; mask the exit
SetBuffer ImageBuffer(level_image)
DrawImage temp,Abs(xoffset)+out(0),-yoffset+out(1)
SetBuffer BackBuffer()
FreeImage temp
SetFont font2
; info screen for level
While Not MouseHit(1)
mx=MouseX():my=MouseY()
k=KeyDown(1): If k=True Exit
Cls
TileImage logo,0,0
DrawBlock small_level,width/2-ImageWidth(small_level)/2,50
Color 255,255,0
Text width/2-StringWidth(t$)/2,10,t$
Text 360,230,"Number of lemmings "+Right$("00"+maxlem,2)
Text 360,260,"Number of lemmings to save "+Right$("00"+tosave,2) 
min$="Time: "+Right$("00"+mins,2):min$=min$+":":sec$=Right$("00"+secs,2):min$=min$+sec$
Text 360,290,"Time to complete this level  "+Right$(min$,5)
Text 100,140,"Climbers ":Text 190,140,Right$("00"+buttons(1,4),2)
Text 100,180,"Floaters ":Text 190,180,Right$("00"+buttons(2,4),2)
Text 100,220,"Bombers  ":Text 190,220,Right$("00"+buttons(3,4),2)
Text 100,260,"Blockers ":Text 190,260,Right$("00"+buttons(4,4),2)
Text 100,300,"Builders ":Text 190,300,Right$("00"+buttons(5,4),2)
Text 100,340,"Bashers  ":Text 190,340,Right$("00"+buttons(6,4),2)
Text 100,380,"Miners   ":Text 190,380,Right$("00"+buttons(7,4),2)
Text 100,420,"Diggers  ":Text 190,420,Right$("00"+buttons(8,4),2)
Text width/4,520,"LEFT MOUSE BUTTON TO CONTINUE?"
DrawImage mouse,mx,my,2
Flip
Wend
gfxbank=GrabBank() 
For i=1 To 8 
    Fade(gfxbank) 
    Flip 
Next 
FreeBank gfxbank
If k=True endgame 
lemaddtimer=MilliSecs()
End Function
;
; add lemming
;
Function addlemming()
If numlem<maxlem And nuked=False And paused=False
  If lemaddtimer+lemaddwait<MilliSecs() 
    l.lemming=New lemming

    l\x=Abs(oldxoffset)+in(0)+40:l\y=in(1)-20:l\dir=1:l\flag0=False:l\flag1=0:l\flag2=False:l\image=0
    l\bimage=108:l\frame=0:l\framerate=0.2:l\maxframe=7
    l\job=0:l\state=0:l\bstate=0:l\planks=0:l\walker=True
    l\climber=False:l\floater=False:l\bomber=False:l\blocker=False
    l\builder=False:l\basher=False:l\miner=False:l\digger=False

    numlem=numlem+1:out(3)=out(3)+1
    lemaddtimer=MilliSecs()
  End If
End If
End Function
;
; render lemmings
;
Function render_lemmings()
; draw each lemming
For l.lemming=Each lemming
   DrawImage sprites,xoffset+l\x-32,yoffset+l\y-31,l\image+l\frame
   If l\bomber=True DrawImage sprites,xoffset+l\x-32,yoffset+l\y-60,l\bimage
   Color 0,255,0
   px=width/2-ImageWidth(box_image)/2
   py=height-ImageHeight(box_image)-20
   l\sx=(px+l\x/10):l\sy=(py+l\y/5)
   Rect l\sx,l\sy,2,2,1
Next
End Function
;
; the timer
;
Function updatetimer()
If paused=True Return
seconds=Right$(CurrentTime$(),2)
If oldseconds<>seconds
  If mins>=0 secs=secs-1
  If secs<0 secs=59:If mins>0 mins=mins-1 
  oldseconds=seconds
EndIf
End Function
;
; draw to level map
;
Function fullview(l.lemming,w,h,ox,oy,r,g,b)
SetBuffer ImageBuffer(small_level)
Color r,g,b
l\sx=(l\x/10):l\sy=(l\y/5)
Rect l\sx-ox,l\sy-oy,w,h,1 
SetBuffer BackBuffer()
End Function 
;
; check mouse
;
Function check_mouse(mx,my,md,mh)
mi=False
For l.lemming=Each lemming ; loop thru all lemmings
   lx=l\x+xoffset:ly=l\y+yoffset
   If RectsOverlap(lx,ly,1,1,mx,my+14,28,28)
     mi=True:tex$=info$(l\job)
     If l\job=0 And (l\climber=True Or l\floater=True) tex$=info$(8)
     If mh=True And paused=False
       ; climber
       If selected=1 And buttons(1,4)>0 And l\climber=False
         l\climber=True:buttons(1,4)=buttons(1,4)-1:PlaySound click2:Exit
       EndIf
       ; floater
       If selected=2 And buttons(2,4)>0 And l\floater=False
         l\floater=True:buttons(2,4)=buttons(2,4)-1:PlaySound click2:Exit
       EndIf
       ; bomber
       If selected=3 And buttons(3,4)>0 And l\bomber=False
         l\bomber=True:buttons(3,4)=buttons(3,4)-1:PlaySound click2:Exit
       EndIf
       ; blocker
       If selected=4 And buttons(4,4)>0 And l\blocker=False And l\flag1=0
         If l\job<>1 And l\job<>2
           l\blocker=True:l\job=3:buttons(4,4)=buttons(4,4)-1
           vx=Floor#(l\x)/10:vy=Floor#(l\y)/10:map(vx,vy)=1:PlaySound click2:Exit
         EndIf
       EndIf
       ; builder
       If selected=5 And buttons(5,4)>0 And l\builder=False And l\flag1=0
         If l\job=0 Or l\job=5 Or l\job=6 Or l\job=7
           l\builder=True:l\basher=False:l\miner=False:l\digger=False:l\planks=0
           l\flag0=0:l\frame=0:l\state=0:l\job=4:buttons(5,4)=buttons(5,4)-1:PlaySound click2:Exit
         EndIf
       EndIf
       ; basher
       If selected=6 And buttons(6,4)>0 And l\basher=False And l\flag1=0
         If l\job=0 Or l\job=4 Or l\job=6 Or l\job=7
           If l\miner=True And l\dir=0 l\x=l\x-6
           If l\miner=True And l\dir=1 l\x=l\x+6
           l\basher=True:l\builder=False:l\miner=False:l\digger=False:l\planks=0
           l\flag0=0:l\frame=0:l\state=0:l\job=5:buttons(6,4)=buttons(6,4)-1:PlaySound click2:Exit
         EndIf
       EndIf
       ; miner
       If selected=7 And buttons(7,4)>0 And l\miner=False And l\flag1=0
         If l\job=0 Or l\job=4 Or l\job=5 Or l\job=7
           l\miner=True:l\builder=False:l\basher=False:l\digger=False:l\planks=0
           l\flag0=0:l\frame=0:l\state=0:l\job=6:buttons(7,4)=buttons(7,4)-1:PlaySound click2:Exit
         EndIf
       EndIf
       ; digger
       If selected=8 And buttons(8,4)>0 And l\digger=False And l\flag1=0
         If l\job=0 Or l\job=4 Or l\job=5 Or l\job=6
           l\digger=True:l\builder=False:l\basher=False:l\miner=False:l\planks=0
           l\flag0=0:l\frame=0:l\state=0:l\job=7:l\y=l\y+4:buttons(8,4)=buttons(8,4)-1
           PlaySound click2:Exit
         EndIf
       EndIf
     EndIf
   EndIf
Next
; job selecter
If mi=True mouse_image=1 Else mouse_image=0:tex$="" 
If my>ImageHeight(level_image)+yoffset mouse_image=2
For d=1 To 13
   x=buttons(d,1):y=buttons(d,2):z=buttons(d,3)
   If d<11
     Color 254,254,254
     Text x+14,y+5,Right$("00"+buttons(d,4),2)
   EndIf
   If z=1 DrawImage box_icon,x,y
   If d<9
     If RectsOverlap(mx,my,1,1,x-1,y-1,40,73)
       If md And buttons(d,3)=0
         buttons(d,3)=1:n=d:selected=d:chan=PlaySound(click1)
         For t=1 To 13
            If buttons(t,3)=1 And t<>n buttons(t,3)=0
         Next
       EndIf
     EndIf
   EndIf
Next
; general adjustment selecter
; plus
x=buttons(9,1):y=buttons(9,2)
If RectsOverlap(mx,my,1,1,x-1,y-1,40,73) And md=True
  ;chan=PlaySound(click1)
  buttons(9,4)=buttons(9,4)+1:lemaddwait=lemaddwait-100:td(10)=lemaddwait
  If buttons(9,4)>99 buttons(9,4)=99:lemaddwait=300:td(10)=lemaddwait
EndIf
; minus
x=buttons(10,1):y=buttons(10,2)
If RectsOverlap(mx,my,1,1,x-1,y-1,40,73) And md=True
  ;chan=PlaySound(click1)
  buttons(9,4)=buttons(9,4)-1:lemaddwait=lemaddwait+100:td(10)=lemaddwait
  If buttons(9,4)<buttons(10,4) buttons(9,4)=buttons(10,4):lemaddwait=lemaddwait-100:td(10)=lemaddwait
EndIf
; paws
x=buttons(11,1):y=buttons(11,2)
If RectsOverlap(mx,my,1,1,x-1,y-1,40,73) And mh=True
  chan=PlaySound(click1)
  If paused=True paused=False Else paused=True    
EndIf
; fast forward
x=buttons(12,1):y=buttons(12,2)
If RectsOverlap(mx,my,1,1,x-1,y-1,40,73) And mh=True
  chan=PlaySound(click1)
  If gamespeed=0
    gamespeed=5:td(10)=lemaddwait:lemaddwait=300
  Else
    gamespeed=0:lemaddwait=td(10)
  EndIf  
EndIf
; nuke em all
x=buttons(13,1):y=buttons(13,2):z=buttons(13,4)
If RectsOverlap(mx,my,1,1,x-1,y-1,40,73) And mh=True
  chan=PlaySound(click1)
  buttons(13,4)=buttons(13,4)+1
  If buttons(13,4)=2
    For l.lemming=Each lemming 
       l\bomber=True:maxlem=numlem:nuked=True
    Next
  EndIf
EndIf
DrawImage mouse,mx,my,mouse_image
End Function
;
; update game
;
Function updategame(mx,my,md,mh)
DrawBlock level_image,xoffset,yoffset
DrawBlock box_image,width/2-ImageWidth(box_image)/2,height-ImageHeight(box_image)-20
DrawBlock icons,0,height-ImageHeight(icons)-100
DrawBlock small_level,width/2-ImageWidth(box_image)/2+1,height-ImageHeight(box_image)-19
bx=-xoffset/10
DrawImage box_cursor,bx+width/2-ImageWidth(box_image)/2+1,height-ImageHeight(box_image)-19
; the entrance
tx=Abs(oldxoffset)+xoffset
DrawImage entrance,tx+in(0),in(1),in(2)
; the exit 
DrawImage home,tx+out(0),out(1),out(2)
out(2)=out(2)+0.2:If out(2)>3 out(2)=0
;
;Text 0,0,numlem+"   "+maxlem+"   "+saved+"   "+dead
;Text 0,30,mx+"  "+my+"   "+xoffset+"   "+lemaddwait
renderfrags()
; minutes
min$="Time: "+Right$("00"+mins,2)
min$=min$+":"
; seconds
sec$=Right$("00"+secs,2)
min$=min$+sec$
SetFont font2
Color 0,255,0
Text 630,450,min$
Text 10,385,tex$
Text 500,385,"In: "+Right$("00"+saved,2)
Text 640,385,"Out: "+Right$("00"+Int(out(3)),2)
SetFont font1
End Function
;
; update explosion
;
Function updatefrags()
If paused=True Return
For f.Frag=Each Frag
   f\x=f\x+f\xs
   f\y=f\y+f\ys
   f\ys=f\ys+.1
   If f\x<0 Or f\x>=ImageWidth(level_image) Or f\y>=ImageHeight(level_image)+yoffset
     Delete f:numfrags=numfrags-1
   EndIf
Next
End Function
;
; free mem and quit
;
Function endgame()
EndGraphics
VWait 
; free up memory
; free the timer
FreeTimer timer
; free fonts
FreeFont font1:FreeFont font2
; free sounds
FreeSound die1:FreeSound die2:FreeSound die3:FreeSound pop:FreeSound click1
FreeSound click2:FreeSound last3
FreeSound door:FreeSound letsgo:FreeSound yippee
; free graphics
FreeImage logo:FreeImage splash1:FreeImage splash2
FreeImage level_image:FreeImage small_level:FreeImage home:FreeImage entrance:FreeImage box_image
FreeImage sprites:FreeImage box_cursor:FreeImage box_icon:FreeImage icons:FreeImage mouse
FreeImage masks1:FreeImage masks2:FreeImage masks3
VWait
End
End Function
;
; render explosion
;
Function renderfrags()
For f.Frag=Each Frag
   Color Rnd(255),Rnd(255),Rnd(255)
   Rect xoffset+f\x-8,yoffset+f\y-31,1,1
Next
End Function
;
; grab the graphics buffer
;
Function GrabBank() 
w=GraphicsWidth() 
h=GraphicsHeight() 
bank=CreateBank(w*h*4)     
gbuffer=GraphicsBuffer() 
LockBuffer gbuffer 
For y=0 To h-1 
   For x=0 To w-1 
      PokeInt bank,o,ReadPixelFast(x,y) 
      o=o+4 
   Next 
Next 
UnlockBuffer gbuffer     
Return bank 
End Function 
;
; fade the buffer
;
Function Fade(bank) 
w=GraphicsWidth()-1:h=GraphicsHeight()-1 
gbuffer=GraphicsBuffer()
dec=32 ; the higher the number the faster the fade. (even numbers only) 
LockBuffer gbuffer 
For y=0 To h 
   For x=0 To w 
      rgb=PeekInt(bank,o) 
      r=rgb Shr 16 And 255:r=r-dec:If r<0 r=0
      g=rgb Shr 8 And 255:g=g-dec:If g<0 g=0
      b=rgb And 255:b=b-dec:If b<0 b=0
      rgb=(r Shl 16)+(g Shl 8)+b
      WritePixelFast x,y,rgb 
      PokeInt(bank,o,rgb) 
      o=o+4 
   Next 
Next 
UnlockBuffer gbuffer     
End Function
 